# CMSIS DSP Software Library: Vector Addition

# Vector Addition
[Basic Math Functions]

## Functions

void | arm_add_f32 (float32_t *pSrcA, float32_t *pSrcB, float32_t *pDst, uint32_t blockSize)
void | arm_add_q31 (q31_t *pSrcA, q31_t *pSrcB, q31_t *pDst, uint32_t blockSize)
void | arm_add_q15 (q15_t *pSrcA, q15_t *pSrcB, q15_t *pDst, uint32_t blockSize)
void | arm_add_q7 (q7_t *pSrcA, q7_t *pSrcB, q7_t *pDst, uint32_t blockSize)

## Detailed Description

Element-by-element addition of two vectors.

         pDst[n] = pSrcA[n] + pSrcB[n],   0 <= n < blockSize.

There are separate functions for floating-point, Q7, Q15, and Q31 data types.

## Function Documentation

void arm_add_f32 | ( | float32_t * | pSrcA,
|  | float32_t * | pSrcB,
|  | float32_t * | pDst,
|  | uint32_t | blockSize
| ) |  |

Floating-point vector addition.

Parameters:

  [in] | *pSrcA | points to the first input vector
  [in] | *pSrcB | points to the second input vector
  [out] | *pDst | points to the output vector
  [in] | blockSize | number of samples in each vector

Returns:
  none.

Examples:
  arm_dotproduct_example_f32.c, and arm_sin_cos_example_f32.c.

Definition at line 65 of file arm_add_f32.c.

void arm_add_q31 | ( | q31_t * | pSrcA,
|  | q31_t * | pSrcB,
|  | q31_t * | pDst,
|  | uint32_t | blockSize
| ) |  |

Q31 vector addition.

Parameters:

  [in] | *pSrcA | points to the first input vector
  [in] | *pSrcB | points to the second input vector
  [out] | *pDst | points to the output vector
  [in] | blockSize | number of samples in each vector

Returns:
  none.

Scaling and Overflow Behavior:

  The function uses saturating arithmetic. Results outside of the allowable Q31 range[0x80000000 0x7FFFFFFF] will be saturated.

Definition at line 59 of file arm_add_q31.c.

void arm_add_q15 | ( | q15_t * | pSrcA,
|  | q15_t * | pSrcB,
|  | q15_t * | pDst,
|  | uint32_t | blockSize
| ) |  |

Q15 vector addition.

Parameters:

  [in] | *pSrcA | points to the first input vector
  [in] | *pSrcB | points to the second input vector
  [out] | *pDst | points to the output vector
  [in] | blockSize | number of samples in each vector

Returns:
  none.

Scaling and Overflow Behavior:

  The function uses saturating arithmetic. Results outside of the allowable Q15 range [0x8000 0x7FFF] will be saturated.

Definition at line 58 of file arm_add_q15.c.

void arm_add_q7 | ( | q7_t * | pSrcA,
|  | q7_t * | pSrcB,
|  | q7_t * | pDst,
|  | uint32_t | blockSize
| ) |  |

Q7 vector addition.

Parameters:

  [in] | *pSrcA | points to the first input vector
  [in] | *pSrcB | points to the second input vector
  [out] | *pDst | points to the output vector
  [in] | blockSize | number of samples in each vector

Returns:
  none.

Scaling and Overflow Behavior:

  The function uses saturating arithmetic. Results outside of the allowable Q7 range [0x80 0x7F] will be saturated.

Definition at line 58 of file arm_add_q7.c.

All Data Structures Files Functions Variables Typedefs Enumerations Enumerator Defines